Michael Ellerman | 5c02cd2 | 2008-04-24 12:08:22 +1000 | [diff] [blame] | 1 | #!/bin/sh |
| 2 | # |
| 3 | # Copyright © 2008 IBM Corporation |
| 4 | # |
| 5 | # This program is free software; you can redistribute it and/or |
| 6 | # modify it under the terms of the GNU General Public License |
| 7 | # as published by the Free Software Foundation; either version |
| 8 | # 2 of the License, or (at your option) any later version. |
| 9 | |
| 10 | # This script checks prom_init.o to see what external symbols it |
| 11 | # is using, if it finds symbols not in the whitelist it returns |
| 12 | # an error. The point of this is to discourage people from |
| 13 | # intentionally or accidentally adding new code to prom_init.c |
| 14 | # which has side effects on other parts of the kernel. |
| 15 | |
| 16 | # If you really need to reference something from prom_init.o add |
| 17 | # it to the list below: |
| 18 | |
Christophe Leroy | 26deb04 | 2019-04-26 16:23:26 +0000 | [diff] [blame^] | 19 | grep "^CONFIG_KASAN=y$" .config >/dev/null |
| 20 | if [ $? -eq 0 ] |
| 21 | then |
| 22 | MEM_FUNCS="__memcpy __memset" |
| 23 | else |
| 24 | MEM_FUNCS="memcpy memset" |
| 25 | fi |
| 26 | |
Michael Ellerman | 5c02cd2 | 2008-04-24 12:08:22 +1000 | [diff] [blame] | 27 | WHITELIST="add_reloc_offset __bss_start __bss_stop copy_and_flush |
Christophe Leroy | 26deb04 | 2019-04-26 16:23:26 +0000 | [diff] [blame^] | 28 | _end enter_prom $MEM_FUNCS reloc_offset __secondary_hold |
Michael Ellerman | 5c02cd2 | 2008-04-24 12:08:22 +1000 | [diff] [blame] | 29 | __secondary_hold_acknowledge __secondary_hold_spinloop __start |
Aneesh Kumar K.V | 7a22d63 | 2018-03-30 17:39:02 +0530 | [diff] [blame] | 30 | strcmp strcpy strlcpy strlen strncmp strstr kstrtobool logo_linux_clut224 |
Benjamin Herrenschmidt | 27f4488 | 2011-09-19 18:27:58 +0000 | [diff] [blame] | 31 | reloc_got2 kernstart_addr memstart_addr linux_banner _stext |
Michael Ellerman | e2500be | 2014-06-24 17:17:47 +1000 | [diff] [blame] | 32 | __prom_init_toc_start __prom_init_toc_end btext_setup_display TOC." |
Michael Ellerman | 5c02cd2 | 2008-04-24 12:08:22 +1000 | [diff] [blame] | 33 | |
| 34 | NM="$1" |
| 35 | OBJ="$2" |
| 36 | |
| 37 | ERROR=0 |
| 38 | |
Benjamin Herrenschmidt | 2c51d97 | 2018-10-15 13:49:59 +1100 | [diff] [blame] | 39 | function check_section() |
| 40 | { |
| 41 | file=$1 |
| 42 | section=$2 |
| 43 | size=$(objdump -h -j $section $file 2>/dev/null | awk "\$2 == \"$section\" {print \$3}") |
| 44 | size=${size:-0} |
| 45 | if [ $size -ne 0 ]; then |
| 46 | ERROR=1 |
| 47 | echo "Error: Section $section not empty in prom_init.c" >&2 |
| 48 | fi |
| 49 | } |
| 50 | |
Michael Ellerman | 5c02cd2 | 2008-04-24 12:08:22 +1000 | [diff] [blame] | 51 | for UNDEF in $($NM -u $OBJ | awk '{print $2}') |
| 52 | do |
| 53 | # On 64-bit nm gives us the function descriptors, which have |
| 54 | # a leading . on the name, so strip it off here. |
| 55 | UNDEF="${UNDEF#.}" |
| 56 | |
| 57 | if [ $KBUILD_VERBOSE ]; then |
| 58 | if [ $KBUILD_VERBOSE -ne 0 ]; then |
| 59 | echo "Checking prom_init.o symbol '$UNDEF'" |
| 60 | fi |
| 61 | fi |
| 62 | |
| 63 | OK=0 |
| 64 | for WHITE in $WHITELIST |
| 65 | do |
| 66 | if [ "$UNDEF" = "$WHITE" ]; then |
| 67 | OK=1 |
| 68 | break |
| 69 | fi |
| 70 | done |
| 71 | |
Kumar Gala | da3de6d | 2008-06-13 07:20:58 +1000 | [diff] [blame] | 72 | # ignore register save/restore funcitons |
Andreas Schwab | fe921c8 | 2014-09-13 10:20:17 +0200 | [diff] [blame] | 73 | case $UNDEF in |
| 74 | _restgpr_*|_restgpr0_*|_rest32gpr_*) |
Kumar Gala | da3de6d | 2008-06-13 07:20:58 +1000 | [diff] [blame] | 75 | OK=1 |
Andreas Schwab | fe921c8 | 2014-09-13 10:20:17 +0200 | [diff] [blame] | 76 | ;; |
| 77 | _savegpr_*|_savegpr0_*|_save32gpr_*) |
Stephen Rothwell | 5afd878 | 2010-06-29 20:04:22 +0000 | [diff] [blame] | 78 | OK=1 |
Andreas Schwab | fe921c8 | 2014-09-13 10:20:17 +0200 | [diff] [blame] | 79 | ;; |
| 80 | esac |
Kumar Gala | da3de6d | 2008-06-13 07:20:58 +1000 | [diff] [blame] | 81 | |
Michael Ellerman | 5c02cd2 | 2008-04-24 12:08:22 +1000 | [diff] [blame] | 82 | if [ $OK -eq 0 ]; then |
| 83 | ERROR=1 |
| 84 | echo "Error: External symbol '$UNDEF' referenced" \ |
| 85 | "from prom_init.c" >&2 |
| 86 | fi |
| 87 | done |
| 88 | |
Benjamin Herrenschmidt | 2c51d97 | 2018-10-15 13:49:59 +1100 | [diff] [blame] | 89 | check_section $OBJ .data |
| 90 | check_section $OBJ .bss |
| 91 | check_section $OBJ .init.data |
| 92 | |
Michael Ellerman | 5c02cd2 | 2008-04-24 12:08:22 +1000 | [diff] [blame] | 93 | exit $ERROR |